﻿using System;
using System.Runtime.InteropServices;

namespace Juniper.Ssi.WM
{
   internal static class NativeMethods
   {
      [DllImport("SSIDLL.dll")]
      internal static extern ErrorCode SSIConnect(IntPtr hwnd, int baud, int port);

      [DllImport("SSIDLL.dll")]
      internal static extern ErrorCode SSIDisconnect(IntPtr hwnd, int nComPort);

      [DllImport("SSIDLL.dll")]
      internal static extern ErrorCode AbortImageXfer(int nComPort);

      [DllImport("SSIDLL.dll")]
      internal static extern ErrorCode AbortMacroPdf(int nComPort);

      [DllImport("SSIDLL.dll")]
      internal static extern ErrorCode AimOn(int nComPort);

      [DllImport("SSIDLL.dll")]
      internal static extern ErrorCode AimOff(int nComPort);

      [DllImport("SSIDLL.dll")]
      internal static extern ErrorCode EnterLowPwrMode(int nComPort);

      [DllImport("SSIDLL.dll")]
      internal static extern ErrorCode FlushMacroPdf(int nComPort);

      [DllImport("SSIDLL.dll")]
      internal static extern ErrorCode LedOn(int nComPort, byte nLedSelection);

      [DllImport("SSIDLL.dll")]
      internal static extern ErrorCode LedOff(int nComPort, byte nLedSelection);

      [DllImport("SSIDLL.dll")]
      internal static extern ErrorCode PullTrigger(int nComPort);

      [DllImport("SSIDLL.dll")]
      internal static extern ErrorCode ReleaseTrigger(int nComPort);

      [DllImport("SSIDLL.dll")]
      internal static extern ErrorCode RequestAllParameters(int nComPort);

      [DllImport("SSIDLL.dll")]
      internal static extern ErrorCode RequestParameters(byte[] parameters, int parameterBytes, int nComPort);

      [DllImport("SSIDLL.dll")]
      internal static extern ErrorCode RequestScannerCapabilities(int nComPort);

      [DllImport("SSIDLL.dll")]
      internal static extern int ReturnDLLVersion();

      [DllImport("SSIDLL.dll")]
      internal static extern ErrorCode ScanEnable(int nComPort);

      [DllImport("SSIDLL.dll")]
      internal static extern ErrorCode ScanDisable(int nComPort);

      [DllImport("SSIDLL.dll")]
      internal static extern ErrorCode SetCapabilitiesBuffer(int nComPort, byte[] pData, int maxLength);

      [DllImport("SSIDLL.dll")]
      internal static extern ErrorCode SetDecodeBuffer(int nComPort, byte[] pData, int maxLength);

      [DllImport("SSIDLL.dll")]
      internal static extern ErrorCode SetImageBuffer(int nComPort, byte[] pData, int maxLength);

      [DllImport("SSIDLL.dll")]
      internal static extern ErrorCode SetParameterBuffer(int nComPort, byte[] pData, int maxLength);

      [DllImport("SSIDLL.dll")]
      internal static extern ErrorCode SetParameters(byte[] parameters, int parameterBytes, int nComPort);

      [DllImport("SSIDLL.dll")]
      internal static extern ErrorCode SetParamPersistance(int nComPort, int bPersist);

      [DllImport("SSIDLL.dll")]
      internal static extern ErrorCode SetVersionBuffer(int nComPort, byte[] pData, int maxLength);

      [DllImport("SSIDLL.dll")]
      internal static extern ErrorCode SetVideoBuffer(int nComPort, byte[] pData, int maxLength);

      [DllImport("SSIDLL.dll")]
      internal static extern ErrorCode SnapShot(int nComPort);

      [DllImport("SSIDLL.dll")]
      internal static extern ErrorCode SoundBeeper(int nComPort, BeepCode beepCode);

      [DllImport("SSIDLL.dll")]
      internal static extern ErrorCode TransmitVersion(int nComPort);

      [DllImport("SSIDLL.dll")]
      internal static extern ErrorCode TransmitVideo(int nComPort);
   }
}