﻿namespace Juniper.Ssi.WM
{
   public static class SsiErrorHandler
   {
      /// <summary>
      /// Gets the exception.
      /// </summary>
      /// <param name="errorCode">The error code.</param>
      /// <returns></returns>
      public static SsiException GetException(ErrorCode errorCode)
      {
         return new SsiException(errorCode, GetErrorCodeMessage(errorCode));
      }

      /// <summary>
      /// Gets the error code message.
      /// </summary>
      /// <param name="errorCode">The error code.</param>
      /// <returns></returns>
      private static string GetErrorCodeMessage(ErrorCode errorCode)
      {
         switch (errorCode)
         {
            case ErrorCode.ErrorSsiNoObject:
               return ErrorMessages.ERR_SSI_NOOBJECT;
            default:
               return string.Empty;
         }
      }
   }
}