﻿using System;
using Microsoft.WindowsCE.Forms;

namespace Juniper.Ssi.WM
{
   public class SsiInterceptor : MessageWindow
   {
      private const int WM_APP = 0x8000;

      private const int WM_DECODE = WM_APP + 1;

      private const int WM_IMAGE = WM_APP + 2;

      private const int WM_VIDEOIMAGE = WM_APP + 3;

      private const int WM_ERROR = WM_APP + 4;

      private const int WM_TIMEOUT = WM_APP + 5;

      private const int WM_CMDCOMPLETEMSG = WM_APP + 6;

      private const int WM_XFERSTATUS = WM_APP + 7;

      private const int WM_SWVERSION = WM_APP + 8;

      private const int WM_PARAMS = WM_APP + 9;

      private const int WM_CAPABILITIES = WM_APP + 10;

      private const int WM_EVENT = WM_APP + 11;

      public event EventHandler CapabilitiesReturned;

      public event EventHandler ErrorOccurred;

      protected override void WndProc(ref Message m)
      {
         switch(m.Msg)
         {
            case WM_DECODE:
               break;
            case WM_IMAGE:
               break;
            case WM_VIDEOIMAGE:
               break;
            case WM_ERROR:
                if (ErrorOccurred != null)
                {
                    ErrorOccurred(this, EventArgs.Empty);
                }
               break;
            case WM_TIMEOUT:
               break;
            case WM_CMDCOMPLETEMSG:
               break;
            case WM_XFERSTATUS:
               break;
            case WM_SWVERSION:
               break;
            case WM_PARAMS:
               break;
            case WM_CAPABILITIES:
               TriggerCapabilitiesReturned();
               break;
            case WM_EVENT:
               break;
         }

         base.WndProc(ref m);
      }

      private void TriggerCapabilitiesReturned()
      {
         if (CapabilitiesReturned != null)
         {
            CapabilitiesReturned(this, EventArgs.Empty);
         }
      }
   }
}