﻿using System;
using System.Threading;
using System.Windows.Forms;
using Juniper.Ssi.WM;

namespace Juniper.Ssi.Mobile.TestGui
{
   public partial class MainForm : Form
   {
      private BarcodeScanner _barcodeScanner;

      public MainForm()
      {
         InitializeComponent();
      }

      private void button1_Click(object sender, System.EventArgs e)
      {
         try
         {

            AppendMessage("Connecting to scanner...");

            _barcodeScanner = new BarcodeScanner(3, 9600);
            _barcodeScanner.Open();
            _barcodeScanner.CapabilitiesReceived += OnCapabilitiesReceived;

            //AppendMessage("Requesting scanner capabilities...");
            //_barcodeScanner.GetScannerCapabilities();
            AppendMessage("Turning on aiming pattern...");
            _barcodeScanner.AimOn();
            //AppendMessage("Beeping the device...");
            //barcodeReader.Beep(BeepCode.TwoLongLow);
            //AppendMessage("Getting the dll version...");
            //var version = barcodeReader.GetDllVersion();
            //AppendMessage(version.ToString());

            Thread.Sleep(4000);

            AppendMessage("Turning off aiming pattern...");
            _barcodeScanner.AimOff();
         }
         catch (SsiException ex)
         {
            if (_barcodeScanner != null)
            {
               _barcodeScanner.Dispose();
            }

            AppendMessage(ex.ErrorCode.ToString());
         }
      }

      private void OnCapabilitiesReceived(object sender, BarcodeScannerDataReceivedEventArgs<BarcodeScannerCapabilities> e)
      {
         
      }

      private void AppendMessage(string message)
      {
         textBox1.Text += message + "\r\n";
      }

      private void textBox1_TextChanged(object sender, System.EventArgs e)
      {
         textBox1.SelectionStart = textBox1.Text.Length;
         textBox1.ScrollToCaret();
         textBox1.Refresh();
      }

      private void button2_Click(object sender, EventArgs e)
      {
         if (_barcodeScanner != null)
         {
            AppendMessage("Disconnecting from barcode.");
            _barcodeScanner.Dispose();
         }
      }
   }
}